from dune.perftool.generation.cache import _RegisteredFunction
from pytools import Record


_backend_mapping = {}


class FuncProxy(Record):
    def __init__(self, interface, name, func):
        Record.__init__(self, interface=interface, name=name, func=func)


def register_backend(interface, name, func):
    _backend_mapping.setdefault(interface, {})
    _backend_mapping[interface][name] = func


def backend(interface=None, name=None):
    assert interface and name

    def _dec(func):
        if not isinstance(func, _RegisteredFunction):
            # Allow order independence of the generator decorators
            # and the backend decorator by delaying the registration
            func = FuncProxy(interface, name, func)
        else:
            register_backend(interface, name, func)

        return func

    return _dec

def get_backend(interface=None, selector=None, **kwargs):
    assert interface and selector

    select = selector(**kwargs)
    assert select in _backend_mapping[interface]

    return _backend_mapping[interface][select]